Skip to content

Device Control Policies

The Device Control Policies service collection provides operations for managing device control policies across your CrowdStrike Falcon environment. Search, create, update, and delete Device Control Policies. Set policy precedence, manage policy members, and configure default device control settings for USB and Bluetooth devices.

LanguageLast Update
Pythonv1.6.1
PowerShellv2.2.9
Gov0.20.0
TypeScriptv0.6.0
Rustv0.7.0
Rubyv1.2.0
OperationDescription
queryCombinedDeviceControlPolicyMembers
query_combined_policy_members
Search for members of a Device Control Policy in your environment by providing a FQL filter and paging details. Returns a set of host details which match the filter criteria.
queryCombinedDeviceControlPolicies
query_combined_policies
Search for Device Control Policies in your environment by providing a FQL filter and paging details. Returns a set of Device Control Policies which match the filter criteria.
getDefaultDeviceControlPolicies
get_default_policies
Retrieve the configuration for the Default Device Control Policy.
updateDefaultDeviceControlPolicies
update_default_policies
Update the configuration for the Default Device Control Policy.
performDeviceControlPoliciesAction
perform_action
Perform the specified action on the Device Control Policies specified in the request.
getDefaultDeviceControlSettings
get_default_settings
Get default device control settings (USB and Bluetooth).
updateDefaultDeviceControlSettings
update_default_settings
Update the configuration for Default Device Control Settings.
setDeviceControlPoliciesPrecedence
set_precedence
Sets the precedence of Device Control Policies based on the order of IDs specified in the request. The first ID specified will have the highest precedence and the last ID specified will have the lowest. You must specify all non-Default Policies for a platform when updating precedence.
getDeviceControlPolicies
get_policies
Retrieve a set of Device Control Policies by specifying their IDs.
getDeviceControlPoliciesV2
get_policies_v2
Get device control policies for the given filter criteria. Supports USB and Bluetooth.
createDeviceControlPolicies
create_policies
Create Device Control Policies by specifying details about the policy to create.
postDeviceControlPoliciesV2
create_policies_v2
Create Device Control Policies by specifying details about the policy to create.
deleteDeviceControlPolicies
delete_policies
Delete a set of Device Control Policies by specifying their IDs.
patchDeviceControlPoliciesClassesV1
update_policy_classes
Update device control policy’s classes (USB and Bluetooth).
updateDeviceControlPolicies
update_policies
Update Device Control Policies by specifying the ID of the policy and details to update.
patchDeviceControlPoliciesV2
update_policies_v2
Update Device Control Policies by specifying the ID of the policy and details to update.
queryDeviceControlPolicyMembers
query_policy_members
Search for members of a Device Control Policy in your environment by providing a FQL filter and paging details. Returns a set of Agent IDs which match the filter criteria.
queryDeviceControlPolicies
query_policies
Search for Device Control Policies in your environment by providing a FQL filter and paging details. Returns a set of Device Control Policy IDs which match the filter criteria.

Search for members of a Device Control Policy in your environment by providing a FQL filter and paging details. Returns a set of host details which match the filter criteria.

GET /policy/combined/device-control-members/v1
Scope Device Control Policies: READ Consumes · Produces application/json
PEP 8 query_combined_policy_members
NameTypeData typeDescription
filterquerystringFQL Syntax formatted string used to limit the results.
idqueryintegerThe ID of the Device Control Policy to search for members of.
limitqueryintegerMaximum number of records to return. (Max: 5000)
offsetqueryintegerStarting index of overall result set from which to return ids.
sortquerystringThe property to sort by. (Ex: modified_timestamp.desc)
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.query_combined_policy_members(id="string",
filter="string",
limit=integer,
offset=integer,
sort="string")
print(response)

Search for Device Control Policies in your environment by providing a FQL filter and paging details. Returns a set of Device Control Policies which match the filter criteria.

GET /policy/combined/device-control/v1
Scope Device Control Policies: READ Consumes · Produces application/json
PEP 8 query_combined_policies
NameTypeData typeDescription
filterquerystringFQL Syntax formatted string used to limit the results.
limitqueryintegerMaximum number of records to return. (Max: 5000)
offsetqueryintegerStarting index of overall result set from which to return ids.
sortquerystringThe property to sort by. (Ex: modified_timestamp.desc)
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.query_combined_policies(filter="string",
limit=integer,
offset=integer,
sort="string")
print(response)

Retrieve the configuration for the Default Device Control Policy.

GET /policy/entities/default-device-control/v1
Scope Device Control Policies: READ Consumes · Produces application/json
PEP 8 get_default_policies

No keywords or arguments accepted.

from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_default_policies()
print(response)

Retrieve the configuration for the Default Device Control Policy.

PATCH /policy/entities/default-device-control/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 update_default_policies
NameTypeData typeDescription
blocked_custom_messagebodystringString containing the blocked notification custom message. When this keyword is provided, you do not need to provide the blocked_notification or body keywords.
blocked_notificationbodydictionaryDictionary containing the blocked notification message. {“custom_message”: “string”, “use_custom”: true}
bodybodydictionaryFull body payload in JSON format.
restricted_custom_messagebodystringString containing the restricted notification custom message. When this keyword is provided, you do not need to provide the restricted_notification or body keywords.
restricted_notificationbodydictionaryDictionary containing the restricted notification message. {“custom_message”: “string”, “use_custom”: true}
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_default_policies(blocked_notification={},
blocked_custom_message="string",
restricted_custom_message="string",
restricted_notification={})
print(response)

Perform the specified action on the Device Control Policies specified in the request.

POST /policy/entities/device-control-actions/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 perform_action
NameTypeData typeDescription
action_namequerystringThe action to perform. Allowed values: add-host-group, add-rule-group, disable, enable, remove-host-group, remove-rule-group.
action_parametersbodylist of dictionariesList of name / value pairs in JSON format.
bodybodydictionaryFull body payload in JSON format.
group_idbody action_parametersstringHost Group ID to apply the policy to. String. Overridden if action_parameters is specified.
idsbodystring or list of stringsDevice Control Policy ID(s) to perform actions against.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.perform_action(action_name="string",
action_parameters=[{"key": "value"}],
group_id="string",
ids=id_list)
print(response)

Get default device control settings (USB and Bluetooth).

GET /policy/entities/device-control-default-settings/v1
Scope Device Control Policies: READ Consumes · Produces application/json
PEP 8 get_default_settings

No keywords or arguments accepted.

from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.get_default_settings()
print(response)

Update the configuration for Default Device Control Settings.

PATCH /policy/entities/device-control-default-settings/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 update_default_settings
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
bluetooth_custom_notificationsbodydictionaryDevice Control policy bluetooth custom notifications.
usb_custom_notificationsbodydictionaryDevice Control policy USB custom notifications.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_default_settings(bluetooth_custom_notifications={},
usb_custom_notifications={},
usb_exceptions=[{"key": "value"}])
print(response)

Sets the precedence of Device Control Policies based on the order of IDs specified in the request. The first ID specified will have the highest precedence and the last ID specified will have the lowest. You must specify all non-Default Policies for a platform when updating precedence.

POST /policy/entities/device-control-precedence/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 set_precedence
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
idsbodystring or list of stringsDevice Control Policy ID(s) to adjust precedence.
platform_namebodystringOS platform name. (Linux, Mac, Windows)
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.set_precedence(ids=id_list, platform_name="string")
print(response)

Retrieve a set of Device Control Policies by specifying their IDs.

GET /policy/entities/device-control/v1
Scope Device Control Policies: READ Consumes · Produces application/json
PEP 8 get_policies
NameTypeData typeDescription
idsquerystring or list of stringsThe ID(s) of the Device Control Policies to return.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_policies(ids=id_list)
print(response)

Get device control policies for the given filter criteria. Supports USB and Bluetooth.

GET /policy/entities/device-control/v1
Scope Device Control Policies: READ Consumes · Produces application/json
PEP 8 get_policies_v2
NameTypeData typeDescription
idsquerystring or list of stringsThe ID(s) of the Device Control Policies to return.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.get_policies_v2(ids=id_list)
print(response)

Create Device Control Policies by specifying details about the policy to create.

POST /policy/entities/device-control/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 create_policies
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
descriptionbodystringDevice Control Policy description.
clone_idbodystringDevice Control Policy ID to clone.
namebodystringDevice Control Policy name.
platform_namebodystringDevice Control Policy platform.
settingsbodydictionaryDevice Control specific settings.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.create_policies(clone_id="string",
description="string",
name="string",
platform_name="string",
settings={})
print(response)

Create Device Control Policies by specifying details about the policy to create.

POST /policy/entities/device-control/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 create_policies_v2
NameTypeData typeDescription
bluetooth_settingsbodydictionaryDevice Control bluetooth specific settings.
bodybodydictionaryFull body payload in JSON format.
descriptionbodystringDevice Control Policy description.
clone_idbodystringDevice Control Policy ID to clone.
namebodystringDevice Control Policy name.
platform_namebodystringDevice Control Policy platform.
usb_settingsbodydictionaryDevice Control USB specific settings.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.create_policies_v2(bluetooth_settings={},
clone_id="string",
description="string",
name="string",
platform_name="string",
usb_settings={})
print(response)

Delete a set of Device Control Policies by specifying their IDs.

DELETE /policy/entities/device-control/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 delete_policies
NameTypeData typeDescription
idsquerystring or list of stringsThe ID(s) of the Device Control Policies to delete.
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
id_list = 'ID1,ID2,ID3' # Can also pass a list here: ['ID1', 'ID2', 'ID3']
response = falcon.delete_policies(ids=id_list)
print(response)

Update device control policy’s classes (USB and Bluetooth).

PATCH /policy/entities/device-control-classes/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 update_policy_classes
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
bluetooth_classesbodydictionaryBluetooth device control policy.
idbodystringDevice Control policy ID.
usb_classesbodydictionaryUSB device control policy.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_policy_classes(bluetooth_classes={},
id="string",
usb_classes={})
print(response)

Update Device Control Policies by specifying the ID of the policy and details to update.

PATCH /policy/entities/device-control/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 update_policies
NameTypeData typeDescription
bodybodydictionaryFull body payload in JSON format.
descriptionbodystringDevice Control Policy description.
idbodystringDevice Control Policy ID to update.
namebodystringDevice Control Policy name.
settingsbodydictionaryDevice control specific policy settings.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_policies(id="string",
description="string",
name="string",
settings={})
print(response)

Update Device Control Policies by specifying the ID of the policy and details to update.

PATCH /policy/entities/device-control/v1
Scope Device Control Policies: WRITE Consumes · Produces application/json
PEP 8 update_policies_v2
NameTypeData typeDescription
bluetooth_settingsbodydictionaryDevice control bluetooth specific policy settings.
bodybodydictionaryFull body payload in JSON format.
descriptionbodystringDevice Control Policy description.
idbodystringDevice Control Policy ID to update.
namebodystringDevice Control Policy name.
usb_settingsbodydictionaryDevice control USB specific policy settings.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.update_policies_v2(bluetooth_settings={},
description="string",
id="string",
name="string",
platform_name="string",
usb_settings={})
print(response)

Search for members of a Device Control Policy in your environment by providing a FQL filter and paging details. Returns a set of Agent IDs which match the filter criteria.

GET /policy/queries/device-control-members/v1
Scope Device Control Policies: READ Consumes · Produces application/json
PEP 8 query_policy_members
NameTypeData typeDescription
filterquerystringFQL Syntax formatted string used to limit the results.
idqueryintegerThe ID of the Device Control Policy to search for members of.
limitqueryintegerMaximum number of records to return. (Max: 5000)
offsetqueryintegerStarting index of overall result set from which to return ids.
sortquerystringThe property to sort by. (Ex: modified_timestamp.desc)
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.query_policy_members(id="string",
filter="string",
limit=integer,
offset=integer,
sort="string")
print(response)

Search for Device Control Policies in your environment by providing a FQL filter and paging details. Returns a set of Device Control Policy IDs which match the filter criteria.

GET /policy/queries/device-control/v1
Scope Device Control Policies: READ Consumes · Produces application/json
PEP 8 query_policies
NameTypeData typeDescription
filterquerystringFQL Syntax formatted string used to limit the results.
limitqueryintegerMaximum number of records to return. (Max: 5000)
offsetqueryintegerStarting index of overall result set from which to return ids.
sortquerystringThe property to sort by. (Ex: modified_timestamp.desc)
parametersquerydictionaryFull query string parameters payload in JSON format.
from falconpy import DeviceControlPolicies
falcon = DeviceControlPolicies(client_id=CLIENT_ID,
client_secret=CLIENT_SECRET
)
response = falcon.query_policies(filter="string",
limit=integer,
offset=integer,
sort="string")
print(response)